/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gpl.fredy.ui;

/**
 * This is a GUI around the XMLImport-Tool.
 *
 *
 *
 * Admin is a Tool around JDBC-enabled SQL-Databases to do basic jobs
 * for DB-Administrations, as create / delete / alter and query tables
 * it also creates indices and generates simple Java-Code to access DBMS-tables
 * and exports data into various formats
 *
 *
 *   Copyright (C)     2010, Fredy Fischer
 *                           sql@hulmen.ch
 *   Postal: Fredy Fischer
 *           Hulmenweg 36
 *           8405 Winterthur
 *           Switzerland
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.sql.*;
import java.io.*;
import javax.swing.*;
import javax.swing.BorderFactory;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.border.*;


import gpl.fredy.share.t_connect;
import java.sql.*;

/**
 *
 * @author afs
 */
public class XMLImportGUI extends JPanel {

    public ImageButton cancel;
    public JCheckBox extendedSettings;
    private JTextField controlFileName;
    private JTextField dataFileName;
    private JTextField jdbcDriver;
    private JTextField connectionURL;
    private JLabel infoBar;
    private String controlFile;
    private String dataFile;
    private t_connect tcon = null;
    private Connection con = null;

    public XMLImportGUI() {
        initGui();
    }

    public XMLImportGUI(t_connect c) {
        setTcon(c);
        initGui();
    }

    public XMLImportGUI(java.sql.Connection c) {
        setCon(c);
        initGui();
    }

    private void initGui() {
        this.setLayout(new BorderLayout());


        this.add(BorderLayout.CENTER, centerPanel());
        this.add(BorderLayout.SOUTH, lowerPanel());
        this.add(BorderLayout.NORTH, infoPanel());
    }

    private JPanel centerPanel() {
        JPanel panel = new JPanel();
        panel.setLayout(new GridBagLayout());

        GridBagConstraints gbc;
        Insets insets = new Insets(2, 2, 2, 2);
        gbc = new GridBagConstraints();
        gbc.weightx = 1.0;
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.insets = insets;

        gbc.gridx = 0;
        gbc.gridy = 0;
        panel.add(filePanel(), gbc);

        // if there is no existing connection then display the values for the JDBC-Stuff
        boolean addCon = false;

        if (getCon() != null) {
            addCon = false;
        }
        if (getTcon() != null) {
            addCon = false;
        }
        if ((getTcon() == null) && (getCon() == null)) {
            addCon = true;
        }

        if (addCon) {

            gbc.gridy = 1;
            panel.add(jdbcSetting(), gbc);

        }
        return panel;
    }

    private JPanel filePanel() {

        controlFileName = new JTextField(30);
        dataFileName = new JTextField(30);

        JPanel panel = new JPanel();

        panel.setLayout(new GridBagLayout());

        GridBagConstraints gbc;
        Insets insets = new Insets(2, 2, 2, 2);
        gbc = new GridBagConstraints();
        gbc.weightx = 1.0;
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.NONE;
        gbc.insets = insets;

        gbc.gridx = 0;
        gbc.gridy = 0;
        panel.add(new JLabel("XML Definition File"), gbc);

        gbc.gridx = 1;
        panel.add(controlFileName, gbc);

        gbc.gridx = 2;
        JButton filer1 = new JButton("...");
        panel.add(filer1, gbc);

        gbc.gridx = 0;
        gbc.gridy = 1;
        panel.add(new JLabel("XML Data File"), gbc);

        gbc.gridx = 1;
        panel.add(dataFileName, gbc);

        gbc.gridx = 2;
        JButton filer2 = new JButton("...");
        panel.add(filer2, gbc);

        filer1.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                JFileChooser chooser = new JFileChooser();
                chooser.setDialogType(JFileChooser.OPEN_DIALOG);
                chooser.setDialogTitle("Select control File");
                chooser.setFileFilter(new gpl.fredy.io.MyFileFilter("xml"));

                int returnVal = chooser.showSaveDialog(null);
                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    //setFile(chooser.getSelectedFile());
                    controlFileName.setText(chooser.getCurrentDirectory()
                            + java.io.File.separator
                            + chooser.getSelectedFile().getName());
                }
            }
        });
        filer2.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                JFileChooser chooser = new JFileChooser();
                chooser.setDialogType(JFileChooser.OPEN_DIALOG);
                chooser.setDialogTitle("Select data File");
                chooser.setFileFilter(new gpl.fredy.io.MyFileFilter("xml"));

                int returnVal = chooser.showSaveDialog(null);
                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    //setFile(chooser.getSelectedFile());
                    dataFileName.setText(chooser.getCurrentDirectory()
                            + java.io.File.separator
                            + chooser.getSelectedFile().getName());
                }
            }
        });


        panel.setBorder(new TitledBorder("File Settings"));
        return panel;
    }

    private JPanel jdbcSetting() {
        JPanel panel = new JPanel();
        jdbcDriver = new JTextField(30);
        connectionURL = new JTextField(30);

        panel.setLayout(new GridBagLayout());

        GridBagConstraints gbc;
        Insets insets = new Insets(2, 2, 2, 2);
        gbc = new GridBagConstraints();
        gbc.weightx = 1.0;
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.NONE;
        gbc.insets = insets;

        gbc.gridx = 0;
        gbc.gridy = 0;
        extendedSettings = new JCheckBox("Use JDBC Driver from control file");
        panel.add(extendedSettings,gbc);

        gbc.gridx = 0;
        gbc.gridy = 1;
        panel.add(new JLabel("JDBC Driver"), gbc);

        gbc.gridx = 1;
        panel.add(jdbcDriver, gbc);

        gbc.gridx = 0;
        gbc.gridy = 2;
        panel.add(new JLabel("JDBC Connection URL"), gbc);

        gbc.gridx = 1;
        panel.add(connectionURL, gbc);

        panel.setBorder(new TitledBorder("JDBC Settings"));
        return panel;
    }

    private JPanel infoPanel() {
        JPanel panel = new JPanel();
        panel.setLayout(new FlowLayout());
        infoBar = new JLabel("Fredy's XML Import");
        panel.add(infoBar);
        return panel;

    }

    private JPanel lowerPanel() {
        // this is the Panel hosting the buttons
        JPanel panel = new JPanel();
        panel.setLayout(new FlowLayout());

        ImageButton load = new ImageButton(null, "createdb.gif", "Load data from file");
        cancel = new ImageButton(null, "exit.gif", "Cancel");


        panel.add(load);
        panel.add(cancel);

        panel.setBorder(new EtchedBorder());

        load.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                infoBar.setText(startImport() + " Rows imported");
            }
        });

        ImageButton help = new ImageButton(null,"help.gif","how it works");
        help.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                howTo();
            }
        });

        panel.add(help);

        return panel;
    }

    private int startImport() {
        if (getTcon() != null) {
            gpl.fredy.sqltools.XMLImport xmlimport = new gpl.fredy.sqltools.XMLImport(controlFileName.getText(), dataFileName.getText(), getTcon());
            return xmlimport.getNoOfRowsInserted();
        }
        if (getCon() != null) {
            gpl.fredy.sqltools.XMLImport xmlimport = new gpl.fredy.sqltools.XMLImport(controlFileName.getText(), dataFileName.getText(), getCon());
            return xmlimport.getNoOfRowsInserted();
        }
        // no connection given , need to do it manually
        gpl.fredy.sqltools.XMLImport xmlimport = new gpl.fredy.sqltools.XMLImport();

        if (!extendedSettings.isSelected()) {
            xmlimport.setJdbcDriver(jdbcDriver.getText());
            xmlimport.setConnectionURL(connectionURL.getText());
        }
        xmlimport.doImport(controlFileName.getText(), dataFileName.getText());

        return xmlimport.getNoOfRowsInserted();

    }

    private void howTo() {
        JDialog dialog = new JDialog();
        dialog.getContentPane().setLayout(new BorderLayout());
        dialog.setTitle("XMLImport How To");

        JTextPane info = new JTextPane();
        info.setText((new gpl.fredy.sqltools.XMLImport()).getInfo());
        info.setEditable(false);

        JScrollPane scrollPane = new JScrollPane(info);
        dialog.getContentPane().add(BorderLayout.CENTER,scrollPane);

        dialog.setModal(true);
        dialog.setPreferredSize(new Dimension(500,250));
        dialog.pack();
        dialog.setVisible(true);

    }


    public static void main(String args[]) {
        JFrame frame = new JFrame("XML Import GUI");
        frame.getContentPane().setLayout(new BorderLayout());
        XMLImportGUI xgui = new XMLImportGUI();
        frame.add(BorderLayout.CENTER, xgui);

        frame.addWindowListener(new WindowAdapter() {

            public void windowActivated(WindowEvent e) {
            }

            public void windowClosed(WindowEvent e) {
            }

            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }

            public void windowDeactivated(WindowEvent e) {
            }

            public void windowDeiconified(WindowEvent e) {
            }

            public void windowIconified(WindowEvent e) {
            }

            public void windowOpened(WindowEvent e) {
            }
        });

        xgui.cancel.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });

        frame.pack();
        frame.setVisible(true);


    }

    /**
     * @return the controlFile
     */
    public String getControlFile() {
        return controlFile;
    }

    /**
     * @param controlFile the controlFile to set
     */
    public void setControlFile(String controlFile) {
        this.controlFile = controlFile;
    }

    /**
     * @return the dataFile
     */
    public String getDataFile() {
        return dataFile;
    }

    /**
     * @param dataFile the dataFile to set
     */
    public void setDataFile(String dataFile) {
        this.dataFile = dataFile;
    }

    /**
     * @return the tcon
     */
    public t_connect getTcon() {
        return tcon;
    }

    /**
     * @param tcon the tcon to set
     */
    public void setTcon(t_connect tcon) {
        this.tcon = tcon;
    }

    /**
     * @return the con
     */
    public Connection getCon() {
        return con;
    }

    /**
     * @param con the con to set
     */
    public void setCon(Connection con) {
        this.con = con;
    }
}
