package gpl.fredy.webmail;

import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.mail.*;
import javax.mail.internet.*;
import java.io.*;
import com.sun.mail.pop3.*;

public class GetHeaders {

    String host;
    public void   setHost(String v) { this.host=v; }
    public String getHost()  { return this.host; }
    
    String user;
    public void   setUser(String v) { this.user = v; }
    public String getUser() { return this.user; }
    
    String password;
    public void   setPassword(String v) { this.password = v; }
    public String getPassword() { return this.password; }
    
    public Vector yourMessages;
    public Vector getYourMessages() { return yourMessages; }

    private Message message[];
    private Store store;
    public Store getStore() { return store; }

    private Session session;
    public Session getSession() { return session; }
 

    public Folder folder;  

    boolean success=true;
    
    /**
     * Get the value of success.
     * @return value of success.
     */
    public boolean isSuccess() {
	return success;
    }
    
    /**
     * Set the value of success.
     * @param v  Value to assign to success.
     */
    public void setSuccess(boolean  v) {
	this.success = v;
    }
    


    public static void main (String args[]) throws Exception {
	
	System.out.println("Fredy's MailHeader Fetcher\n\n" +
			   "Option -h [Host] -u [username] -p [password]\n");
	
        String host      = "localhost";
        String user      = " ";
        String password  = " ";
	int i = 0;
	
	while ( i < args.length) {
	    
	    if ((args[i].equals("-h") ) || (args[i].equals("-host")) ) {		
		i++;
		host=args[i];
	    }    
	    if ((args[i].equals("-u") ) || (args[i].equals("-user")) ) {
		i++;
		user=args[i];	
	    }    
	    if ((args[i].equals("-p") ) || (args[i].equals("-password")) ) {	
	      	i++;
		password=args[i];	
	    }    
            i++;
	}
        GetHeaders gh = new GetHeaders(host, user, password);
        for ( i = 0; i < gh.yourMessages.size();i++) {
	    MessageHeader mh = new MessageHeader();
            mh = (MessageHeader)gh.yourMessages.elementAt(i);
            System.out.println(mh.getSubject());
	}
       
  }

  public GetHeaders(String host, String user, String password) {

     yourMessages = new Vector();
     

    // Create empty properties
	Properties props = new Properties();

    // Get session
	session = Session.getDefaultInstance(props, null);

    // Get the store
	try {
	  store = session.getStore("pop3");
	  //store = session.getStore("imap");
	} catch (NoSuchProviderException nspe) { 
	  System.out.println("no such Provider exception for user " + user + "\n") ;
	  nspe.printStackTrace();
          setSuccess(false);
	}
			     
	try {
	  // Connect to store
	  store.connect(host, user, password);
	  
	  // Get folder
	  folder = store.getFolder("INBOX");        
	
	  // Open read-only
	  folder.open(Folder.READ_ONLY);
       
	  // Get directory
	  message = folder.getMessages();
   
	} catch (MessagingException mxe) {
	  System.out.println("Messaging Exception for user " + user + "\n" );
	  mxe.printStackTrace();
	  setSuccess(false);
	}
	for ( int j=0; j < message.length; j++) {
	 MimeMessage mm = (MimeMessage)message[j];
	 Part        p  = mm;
	 POP3Message pm = (POP3Message)message[j];
	 
	 //yourMessages.addElement((MessageHeader) new MessageHeader(pm));
	 yourMessages.addElement((MessageHeader) new MessageHeader(message[j]));
	}
	/**
	   try {
	   store.close();
	   } catch (MessagingException mxec) {
	   System.out.println("(closeing) Messaging exception for user " + user + "\n" );
	   mxec.printStackTrace();
	  }
	**/
  }
}
     
